package de.duehl.swing.ui.buttons.painted;

import java.awt.Color;

import de.duehl.swing.ui.geometry.PixelPoint;

/**
 * Diese Klasse stellt einen kleinen Schalter zum Beenden von etwas dar.
 *
 * @version 1.01     2025-07-23
 * @author Christian Dühl
 */

public class XInABoxButton extends PaintedButton {

    private static final long serialVersionUID = -1L;

    /** Konstruktor. */
    public XInABoxButton() {
        super(Color.BLACK);
    }

    /**
     * Konstruktor.
     *
     * @param symbolColor
     *            Die Farbe des Symbols.
     */
    public XInABoxButton(Color symbolColor) {
        super(symbolColor);
    }

    /** Zeichnet das Symbol in horizontaler und rechteckiger Anordnung. */
    @Override
    protected void paintHorizontalSymbolRectangle() {
        paintSymbol();
    }

    /** Zeichnet das Symbol in vertikaler und rechteckiger Anordnung. */
    @Override
    protected void paintVerticalSymbolRectangle() {
        paintSymbol();
    }

    /** Zeichnet das Symbol in horizontaler und quadratischer Anordnung. */
    @Override
    protected void paintHorizontalSymbolSquare() {
        paintSymbol();
    }

    /** Zeichnet das Symbol in vertikaler und quadratischer Anordnung. */
    @Override
    protected void paintVerticalSymbolSquare() {
        paintSymbol();
    }

    /** Zeichnet das kleine Kreuz zum Schließen. */
    private void paintSymbol() {
        int width = getWidth();
        int height = getHeight();

        if (isForceSquare()) {
            width = Math.min(width, height);
            height = width;
        }

        int delta = 6;

        int firstLeftPixel = (getWidth() - width)/2;
        int left = firstLeftPixel + delta;

        int lastRightPixel = firstLeftPixel + width - 1;
        int right = lastRightPixel - delta;

        int firstUpperPixel = (getHeight() - height)/2;
        int upper = firstUpperPixel + delta;

        int lastLowerPixel = firstUpperPixel + height - 1;
        int lower = lastLowerPixel - delta;

        paintUnfilledRectangle(
                new PixelPoint(left,  upper),
                new PixelPoint(right, lower)
                );

        int deltaBox = Math.min(width, height)/10;

        paintLine(
                new PixelPoint(left + deltaBox,   upper + deltaBox),
                new PixelPoint(right - deltaBox,  lower - deltaBox)
                );
        paintLine(
                new PixelPoint(left + deltaBox,   lower - deltaBox),
                new PixelPoint(right - deltaBox,  upper + deltaBox)
                );
    }

}
